#! /usr/bin/perl

$path=$ARGV[0];

open (CALENDARIO, ">$path/Esami/Calendario.txt");
open (AULE, "$path/Esami/Aule.txt") || die ("non trovo il file Aule.txt nella directory $path/Esami/ !");

foreach $linea (<AULE>)
{
   ($aula,$posti)=split(' ',$linea);
    $aule_posti{$aula}=$posti;
}

chomp(@list = qx[ls $path/Esami/]);

foreach $e (@list) { 

   open (PROF, ">$path/Esami/$e/Prenotazioni.txt");

   if(-d "$path/Esami/$e/")
   {
      open (APPELLI, "$path/Esami/$e/Appelli.txt") || die ("non trovo il file Appelli.txt nella directory path/Esami/$e/ !" );
            
      foreach $linea (<APPELLI>)
      {
         ($esame,$giorno,$prenotati)=split(' ',$linea);
         $esami_giorni{$esame}=$giorno;
         
         ### per scegliere la più piccola aula assegnabile 
         foreach $aula (sort ({$aule_posti{$a} <=> $aule_posti{$b}} keys %aule_posti))
         {      
            ### se assegnabile
            if ($aule_posti{$aula} >= 2*$prenotati)
            { 
               ### prova ad assegnare
               foreach $es (keys %prenotazioni)
               {
                  $conflitto=0;
                  if($aula eq $prenotazioni{$es} && $esami_giorni{$es} eq $giorno)
                  {
                     $conflitto=1;
                     last;
                  }
               } 
               ## assegna se non trova un conflitto su una aula assegnabile
               if(!$conflitto)
               {
                  $prenotazioni{$esame}=$aula;
                  print CALENDARIO "$esame $e $giorno $aula\n";
                  print PROF "$esame $aula\n";
                  last;
               }
            }##if           
         }#foreach

         if($conflitto)
         {
            print CALENDARIO "$esame $e $giorno --\n";
            print PROF "$esame --\n";
         }
      }#foreach
   }#if

}

